]> mj.ucw.cz Git - saga.git/blobdiff - mst.tex
Intro on RAM data structures.
[saga.git] / mst.tex
diff --git a/mst.tex b/mst.tex
index 9a1ac00d36379acf57e70e7465e26f045cdad073..7e5be9097813a4ab59f639eaa4c520afab9527d8 100644 (file)
--- a/mst.tex
+++ b/mst.tex
@@ -42,7 +42,7 @@ disciplines, the previous work was not well known and the algorithms had to be
 rediscovered several times.
 
 Recently, several significantly faster algorithms were discovered, most notably the
-$\O(m\beta(m,n))$-time algorithm by Fredman and Tarjan \cite{ft:fibonacci} and
+$\O(m\timesbeta(m,n))$-time algorithm by Fredman and Tarjan \cite{ft:fibonacci} and
 algorithms with inverse-Ackermann type complexity by Chazelle \cite{chazelle:ackermann}
 and Pettie \cite{pettie:ackermann}.
 
@@ -51,7 +51,9 @@ and Pettie \cite{pettie:ackermann}.
 This chapter attempts to survery the important algorithms for finding the MST and it
 also presents several new ones.
 
-\section{Basic Properties}
+%--------------------------------------------------------------------------------
+
+\section{Basic properties}
 
 In this section, we will examine the basic properties of spanning trees and prove
 several important theorems to base the algorithms upon. We will follow the theory
@@ -213,7 +215,9 @@ the edge $\pi[e]\in E(G_2)$ is~$f[T]$-light). Therefore by Theorem~\ref{mstthm},
 is the MST of~$G_1$ if and only if $\pi[T]$ is the MST of~$G_2$.
 \qed
 
-\section{The Red-Blue Meta-Algorithm}
+%--------------------------------------------------------------------------------
+
+\section{The Red-Blue meta-algorithm}
 
 Most MST algorithms can be described as special cases of the following procedure
 (again following \cite{tarjan:dsna}):
@@ -254,7 +258,7 @@ $w(e)<w(e')$. \qed
 When an edge is colored red in any step of the procedure, it is not contained in the minimum spanning tree.
 
 \proof
-Again by contradiction. Assume that $e$ is an edge painted red as the heaviest edge
+Again by contradiction. Suppose that $e$ is an edge painted red as the heaviest edge
 of a cycle~$C$ and that $e\in T_{min}$. Removing $e$ causes $T_{min}$ to split to two
 components, let us call them $T_x$ and $T_y$. Some vertices of~$C$ now lie in $T_x$,
 the others in $T_y$, so there must exist in edge $e'\ne e$ such that its endpoints
@@ -297,10 +301,12 @@ are colored, so by the Blue lemma all blue edges are in~$T_{min}$ and by the Red
 lemma all other (red) edges are outside~$T_{min}$, so the blue edges are exactly~$T_{min}$.
 \qed
 
+%--------------------------------------------------------------------------------
+
 \section{Classical algorithms}
 
 The three classical MST algorithms can be easily stated in terms of the Red-Blue meta-algorithm.
-For each of them, we first state the general version of the algorithm, then we prove that
+For each of them, we first show the general version of the algorithm, then we prove that
 it gives the correct result and finally we discuss the time complexity of various
 implementations.
 
@@ -315,8 +321,19 @@ implementations.
 \algout Minimum spanning tree~$T$.
 \endalgo
 
+\lemma\id{boruvkadrop}%
+In each iteration of the algorithm, the number of trees in~$T$ drops at least twice.
+
+\proof
+Each tree gets merged with at least one of its neighbors, so each of the new trees
+contains two or more original trees.
+\qed
+
+\cor
+The algorithm stops in $\O(\log n)$ iterations.
+
 \lemma
-Bor\o{u}vka's algorithm returns the MST of the input graph.
+Bor\o{u}vka's algorithm outputs the MST of the input graph.
 
 \proof
 In every iteration of the algorithm, $T$ is a blue subgraph,
@@ -325,37 +342,26 @@ application of the Blue rule. We stop when the blue subgraph is connected, so
 we do not need the Red rule to explicitly exclude edges.
 
 It remains to show that adding the edges simultaneously does not
-produce a cycle. Consider the first iteration of the algorithm where $T$ contains some cycle~$C$. Without
+produce a cycle. Consider the first iteration of the algorithm where $T$ contains a~cycle~$C$. Without
 loss of generality we can assume that $C=T_1[u_1v_1]\,v_1u_2\,T_2[u_2v_2]\,v_2u_3\,T_3[u_3v_3]\, \ldots \,T_k[u_kv_k]\,v_ku_1$.
 Each component $T_i$ has chosen its lightest incident edge~$e_i$ as either the edge $v_iu_{i+1}$
-or $v_{i-1}u_i$ (indexing cyclically). Assume that $e_1=v_1u_2$ (otherwise we reverse the orientation
-of the cycle). Then $e_2=v_2u_3$ and $w(e_2)<w(e_1)$ and so on, giving $w(e_1)>w(e_2)>\ldots>w(e_k)>w(e_1)$,
-which is a contradiction. (Note that distinctness of edge weights was crucial here.)
+or $v_{i-1}u_i$ (indexing cyclically). Suppose that $e_1=v_1u_2$ (otherwise we reverse the orientation
+of the cycle). Then $e_2=v_2u_3$ and $w(e_2)<w(e_1)$ and we can continue in the same way,
+getting $w(e_1)>w(e_2)>\ldots>w(e_k)>w(e_1)$, which is a contradiction.
+(Note that distinctness of edge weights was crucial here.)
 \qed
 
-\lemma\id{boruvkadrop}%
-In each iteration of the algorithm, the number of trees in~$T$ drops at least twice.
-
-\proof
-Each tree gets merged with at least one neighboring trees, so each of the new trees
-consists of at least two original trees.
-\qed
-
-\cor
-The algorithm stops in $\O(\log n)$ iterations.
-
 \lemma\id{boruvkaiter}%
 Each iteration can be carried out in time $\O(m)$.
 
 \proof
-Following \cite{mm:mst},
-we assign a label to each tree and we keep a mapping from vertices to the
+We assign a label to each tree and we keep a mapping from vertices to the
 labels of the trees they belong to. We scan all edges, map their endpoints
 to the particular trees and for each tree we maintain the lightest incident edge
 so far encountered. Instead of merging the trees one by one (which would be too
-slow), we build an auxilliary graph whose vertices are labels of the original
+slow), we build an auxilliary graph whose vertices are the labels of the original
 trees and edges correspond to the chosen lightest inter-tree edges. We find connected
-components of this graph, these determine how the original labels are translated
+components of this graph, these determine how are the original labels translated
 to the new labels.
 \qed
 
@@ -366,10 +372,10 @@ Bor\o{u}vka's algorithm finds the MST in time $\O(m\log n)$.
 Follows from the previous lemmata.
 \qed
 
-\algn{Jarn\'\i{}k \cite{jarnik:ojistem}, Prim \cite{prim:mst}, Dijkstra \cite{dijkstra:mst}}
+\algn{Jarn\'\i{}k \cite{jarnik:ojistem}, Prim \cite{prim:mst}, Dijkstra \cite{dijkstra:mst}}\id{jarnik}%
 \algo
 \algin A~graph~$G$ with an edge comparison oracle.
-\:$T\=$ a single-vertex tree containing any vertex of~$G$.
+\:$T\=$ a single-vertex tree containing an~arbitrary vertex of~$G$.
 \:While there are vertices outside $T$:
 \::Pick the lightest edge $uv$ such that $u\in V(T)$ and $v\not\in V(T)$.
 \::$T\=T+uv$.
@@ -377,18 +383,19 @@ Follows from the previous lemmata.
 \endalgo
 
 \lemma
-Jarn\'\i{}k's algorithm returns the MST of the input graph.
+Jarn\'\i{}k's algorithm computers the MST of the input graph.
 
 \proof
-During the course of the algorithm, $T$ is always a blue tree. Step~4 corresponds to applying
-the Blue rule to a cut between~$T$ and the rest of the given graph. We need not care about
+If~$G$ is connected, the algorithm always stops. Let us prove that in every step of
+the algorithm, $T$ is always a blue tree. Step~4 corresponds to applying
+the Blue rule to the cut $\delta(T)$ separating~$T$ from the rest of the given graph. We need not care about
 the remaining edges, since for a connected graph the algorithm always stops with the right
 number of blue edges.
 \qed
 
 \impl
 The most important part of the algorithm is finding \em{neighboring edges,} i.e., edges
-going between $T$ and $V(G)\setminus T$. In the straightforward implementation,
+of the cut $\delta(T)$. In a~straightforward implementation,
 searching for the lightest neighboring edge takes $\Theta(m)$ time, so the whole
 algorithm runs in time $\Theta(mn)$.
 
@@ -402,7 +409,7 @@ at most one insertion and at most one deletion, so we spend $\O(m\log n)$ time i
 From this, we can conclude:
 
 \thm
-Jarn\'\i{}k's algorithm finds the MST of the graph in time $\O(m\log n)$.
+Jarn\'\i{}k's algorithm finds the MST of a~given graph in time $\O(m\log n)$.
 
 \rem
 We will show several faster implementations in section \ref{fibonacci}.
@@ -423,21 +430,24 @@ Kruskal's algorithm returns the MST of the input graph.
 
 \proof
 In every step, $T$ is a forest of blue trees. Adding~$e$ to~$T$
-in step~4 applies the Blue rule on the cut separating two components of~$T$ ($e$ is the lightest,
+in step~4 applies the Blue rule on the cut separating some pair of components of~$T$ ($e$ is the lightest,
 because all other edges of the cut have not been considered yet). Dropping~$e$ in step~5 corresponds
-to the red rule on the cycle found ($e$~must be the heaviest, since all other edges of the
-cycle have been already processed). At the end of the algorithm, all edges have been colored,
+to the Red rule on the cycle found ($e$~must be the heaviest, since all other edges of the
+cycle have been already processed). At the end of the algorithm, all edges are colored,
 so~$T$ must be the~MST.
 \qed
 
 \impl
-Except for the initial sorting, which in general takes $\Theta(m\log n)$ time, the only
-other non-trivial operation is detection of cycles. What we need is a data structure
+Except for the initial sorting, which in general takes $\Theta(m\log m)$ time, the only
+other non-trivial operation is the detection of cycles. What we need is a data structure
 for maintaining connected components, which supports queries and edge insertion.
-The following theorem shows that it can be done with a surprising efficiency.
+(This is also known under the name Disjoint Set Union problem, i.e., maintenance
+of an~equivalence relation on a~set with queries on whether two elements are equivalent
+and the operation of joining two equivalence classes into one.)
+The following theorem shows that it can be done with surprising efficiency.
 
 \thmn{Incremental connectivity}%
-When only edge insertions and queries are allowed, connected components
+When only edge insertions and connectivity queries are allowed, connected components
 can be maintained in $\O(\alpha(n))$ time amortized per operation.
 
 \proof
@@ -455,13 +465,15 @@ corresponding components and always recolor the smaller of the two components.
 
 \thm
 Kruskal's algorithm finds the MST of a given graph in time $\O(m\log n)$
-or $\O(m\alpha(n))$ if the edges are already sorted by their weights.
+or $\O(m\timesalpha(n))$ if the edges are already sorted by their weights.
 
 \proof
 Follows from the above analysis.
 \qed
 
-\section{Contractive algorithms}
+%--------------------------------------------------------------------------------
+
+\section{Contractive algorithms}\id{contalg}%
 
 While the classical algorithms are based on growing suitable trees, they
 can be also reformulated in terms of edge contraction. Instead of keeping
@@ -477,11 +489,11 @@ a linear-time algorithm for MST in planar graphs.
 There are two definitions of edge contraction which differ when an edge of a
 triangle is contracted. Either we unify the other two edges to a single edge
 or we keep them as two parallel edges, leaving us with a~multigraph. We will
-use the multigraph version and show that we can easily reduce the multigraph
+use the multigraph version and we will show that we can easily reduce the multigraph
 to a simple graph later. (See \ref{contract} for the exact definitions.)
 
 We only need to be able to map edges of the contracted graph to the original
-edges, so each edge will carry a unique label $\ell(e)$ which will be preserved by
+edges, so each edge will carry a unique label $\ell(e)$ that will be preserved by
 contractions.
 
 \lemman{Flattening a multigraph}\id{flattening}%
@@ -490,17 +502,16 @@ removed and each bundle of parallel edges replaced by its lightest edge.
 Then $G'$~has the same MST as~$G$.
 
 \proof
-Loops can be never used in a spanning tree. If there is a spanning tree~$T$
+Every spanning tree of~$G'$ is a spanning tree of~$G$. In the other direction:
+Loops can be never contained in a spanning tree. If there is a spanning tree~$T$
 containing a removed edge~$e$ parallel to an edge~$e'\in G'$, exchaning $e'$
-for~$e$ in~$T$ makes it lighter. \qed
+for~$e$ makes~$T$ lighter. \qed
 
 \rem Removal of the heavier of a pair of parallel edges can be also viewed
 as an application of the Red rule on a two-edge cycle. And indeed it is, the
 Red-Blue procedure works on multigraphs as well as on simple graphs and all the
-classical algorithms also do. We only would have to be more careful in the
-formulations and proofs, which we preferred to avoid. We also note that most of
-the algorithms can be run on disconnected multigraphs with little or no
-modifications.
+classical algorithms also do. We would only have to be more careful in the
+formulations and proofs, which we preferred to avoid.
 
 \algn{Contractive version of Bor\o{u}vka's algorithm}\id{contbor}
 \algo
@@ -510,7 +521,7 @@ modifications.
 \:While $n(G)>1$:
 \::For each vertex $v_i$ of~$G$, let $e_i$ be the lightest edge incident to~$v_i$.
 \::$T\=T\cup \{ \ell(e_i) \}$. \cmt{Remember labels of all selected edges.}
-\::Contract $G$ along all edges $e_i$, inheriting labels and weights.
+\::Contract $G$ along all edges $e_i$, inheriting labels and weights.\foot{In other words, we ask the comparison oracle for the edge $\ell(e)$ instead of~$e$.}
 \::Flatten $G$, removing parallel edges and loops.
 \algout Minimum spanning tree~$T$.
 \endalgo
@@ -520,7 +531,7 @@ Each iteration of the algorithm can be carried out in time~$\O(m)$.
 
 \proof
 The only non-trivial parts are steps 6 and~7. Contractions can be handled similarly
-to the unions in the original Bor\o{u}vka's algorithm (see \ref{boruvkaiter}).
+to the unions in the original Bor\o{u}vka's algorithm (see \ref{boruvkaiter}):
 We build an auxillary graph containing only the selected edges~$e_i$, find
 connected components of this graph and renumber vertices in each component to
 the identifier of the component. This takes $\O(m)$ time.
@@ -535,7 +546,7 @@ $\O(n+m)=\O(m)$.
 The Contractive Bor\o{u}vka's algorithm finds the MST in time $\O(m\log n)$.
 
 \proof
-As in the original Bor\o{u}vka's algorithm, the number of phases is $\O(\log n)$.
+As in the original Bor\o{u}vka's algorithm, the number of iterations is $\O(\log n)$.
 Then apply the previous lemma.
 \qed
 
@@ -548,42 +559,32 @@ Let us denote the graph considered by the algorithm at the beginning of the $i$-
 iteration by $G_i$ (starting with $G_0=G$) and its number of vertices and edges
 by $n_i$ and $m_i$ respectively. As we already know from the previous lemma,
 the $i$-th iteration takes $\O(m_i)$ time. We are going to prove that the
-$m_i$'s are decreasing exponentially.
+$m_i$'s are decreasing geometrically.
 
-The number of trees in the non-contracting version of the algorithm decreases
-at least twice in each iteration (Lemma \ref{boruvkadrop}) and the
+The number of trees in the non-contracting version of the algorithm drops
+at least by a factor of two in each iteration (Lemma \ref{boruvkadrop}) and the
 same must hold for the number of vertices in the contracting version.
 Therefore $n_i\le n/2^i$.
 
 However, every $G_i$ is planar, because the class of planar graphs is closed
 under edge deletion and contraction. The~$G_i$ is also simple as we explicitly removed multiple edges and
-loops at the end of the previous iteration. So we can use the standard theorem on
+loops at the end of the previous iteration. Hence we can use the standard theorem on
 the number of edges of planar simple graphs (see for example \cite{diestel:gt}) to get $m_i\le 3n_i \le 3n/2^i$.
 From this we get that the total time complexity is $\O(\sum_i m_i)=\O(\sum_i n/2^i)=\O(n)$.
 \qed
 
 \rem
-There are other possibilities how to find the MST of a planar graph in linear time.
-Matsui \cite{matsui:planar} has described an algorithm based on simultaneously
-processing the graph and its dual. The advantage of our approach is that we do not
-need to construct the planar embedding first.
-
-\rem
-To achieve the linear time complexity, the algorithm needs a very careful implementation.
-Specifically, when we represent the graph using adjacency lists, whose heads are stored
-in an array indexed by vertex identifiers, we must renumber the vertices in each iteration.
-Otherwise, unused identifiers could end up taking most of space in the arrays and scans of these
-arrays would have super-linear cost with respect to the size of the current graph~$G_i$.
+There are several other possibilities how to find the MST of a planar graph in linear time.
+For example, Matsui \cite{matsui:planar} has described an algorithm based on simultaneously
+working on the graph and its topological dual. The advantage of our approach is that we do not need
+to construct the planar embedding explicitly. We will show one more linear algorithm
+in section~\ref{minorclosed}.
 
 \rem
-The algorithm can be also implemented on the pointer machine. Representation of graphs
-by pointer structures easily avoids the aforementioned problems with sparse arrays,
-but we need to handle the bucket sorting somehow. We can create a small data structure
-for every vertex and use a pointer to this structure as a unique identifier of the vertex.
-We will also keep a list of all vertex structures. During the bucket sort, each vertex
-structure will contain a pointer to the corresponding bucket and the vertex list will
-define the order of vertices (which can be arbitrary, but has to be fixed).
+To achieve the linear time complexity, the algorithm needs a very careful implementation,
+but we defer the technical details to section~\ref{bucketsort}.
 
+\para
 Graph contractions are indeed a~very powerful tool and they can be used in other MST
 algorithms as well. The following lemma shows the gist:
 
@@ -600,11 +601,11 @@ their counterparts in~$G/e$. Then: $$\mst(G) = \pi^{-1}[\mst(G/e)] + e.$$
 %in a MST.
 The right-hand side of the equality is a spanning tree of~$G$, let us denote it by~$T$ and
 the MST of $G/e$ by~$T'$. If $T$ were not minimum, there would exist a $T$-light edge~$f$ in~$G$
-(according to Theorem \ref{mstthm}). If the path $T[f]$ covered by~$f$ does not contain~$e$,
+(by Theorem \ref{mstthm}). If the path $T[f]$ covered by~$f$ does not contain~$e$,
 then $\pi[T[f]]$ is a path covered by~$\pi(f)$ in~$T'$. Otherwise $\pi(T[f]-e)$ is such a path.
 In both cases, $f$ is $T'$-light, which contradicts the minimality of~$T'$. (We do not have
-a~multigraph version of the theorem, but this direction is a straightforward edge exchange,
-which of course works in multigraphs as well.)
+a~multigraph version of the theorem, but the side we need is a~straightforward edge exchange,
+which obviously works in multigraphs as well.)
 \qed
 
 \rem
@@ -621,8 +622,8 @@ where each edge $v_iv_{i+1}$ has its weight equal to the number of trailing zero
 representation of the number~$i$. The vertex $v_1$ is called a~\df{base} of the distractor.
 
 \rem
-Alternatively, we can use a recursive definition: $D_0$ is a single vertex, $D_k$ consists
-of two disjoint copies of $D_{k-1}$ joined by an edge of weight~$k$.
+Alternatively, we can use a recursive definition: $D_0$ is a single vertex, $D_{k+1}$ consists
+of two disjoint copies of~$D_k$ joined by an edge of weight~$k$.
 
 \figure{distractor.eps}{\epsfxsize}{A~distractor $D_3$ and its evolution (bold edges are contracted)}
 
@@ -638,7 +639,7 @@ exactly $D_{k-1}$ with all weights increased by~1, which does not change the rel
 \defn
 A~\df{hedgehog}~$H_{a,k}$ is a graph consisting of $a$~distractors $D_k^1,\ldots,D_k^a$ of order~$k$
 together with edges of a complete graph on the bases of the distractors. These additional edges
-have unique weights larger than~$k$, i.e., they are heavier than the edges of the distractors.
+have arbitrary weights, but heavier than the edges of all distractors.
 
 \figure{hedgehog.eps}{\epsfxsize}{A~hedgehog $H_{5,2}$ (quills bent to fit in the picture)}
 
@@ -654,7 +655,7 @@ This is monotonely isomorphic to $H_{a,k-1}$.
 
 \thmn{Lower bound for Contractive Bor\o{u}vka}%
 For each $n$ there exists a graph on $\Theta(n)$ vertices and $\Theta(n)$ edges
-such that the Contractive Bor\o{u}vka's algorithm spends time $\Omega(m\log n)$ on it.
+such that the Contractive Bor\o{u}vka's algorithm spends time $\Omega(n\log n)$ on it.
 
 \proof
 Consider the hedgehog $H_{a,k}$ for $a=\lceil\sqrt n\rceil$ and $k=\lceil\log_2 a\rceil$.
@@ -667,179 +668,4 @@ to finish on the remaining complete graph. Each iteration runs on a graph with $
 edges as every $H_{a,k}$ contains a complete graph on~$a$ vertices.
 \qed
 
-\section{Minor-closed graph classes}
-
-The contracting algorithm given in the previous section has been found to perform
-well on planar graphs, but in the general case its time complexity was not linear.
-Can we find some broader class of graphs where the algorithm is still efficient?
-The right context turns out to be the minor-closed graph classes, which are
-closed under contractions and have bounded density.
-
-\defn
-A~graph~$H$ is a \df{minor} of a~graph~$G$ iff it can be obtained
-from a subgraph of~$G$ by a sequence of graph contractions (see \ref{simpcont}).
-
-\defn
-A~class~$\cal C$ of graphs is \df{minor-closed}, when for every $G\in\cal C$ and
-its minor~$H$, the graph~$H$ lies in~$\cal C$ as well. A~class~$\cal C$ is called
-\df{non-trivial} if at least one graph lies in~$\cal C$ and at least one lies outside~$\cal C$.
-
-\example
-Non-trivial minor-closed classes include planar graphs and more generally graphs
-embeddable in any fixed surface. Many nice properties of planar graphs extend
-to these classes, too, most notable the linearity of the number of edges.
-
-\defn\id{density}%
-Let $\cal C$ be a class of graphs. We define its \df{edge density} $\varrho(\cal C)$
-to be the infimum of all~$\varrho$'s such that $m(G) \le \varrho\cdot n(G)$
-holds for every $G\in\cal C$.
-
-\thmn{Density of minor-closed classes}
-A~minor-closed class of graphs has finite edge density if and only if it is
-a non-trivial class.
-
-\proof
-See Theorem 6.1 in \cite{nesetril:minors}, which also lists some other equivalent conditions.
-\qed
-
-\thmn{MST on minor-closed classes \cite{mm:mst}}\id{mstmcc}%
-For any fixed non-trivial minor-closed class~$\cal C$ of graphs, Algorithm \ref{contbor} finds
-the MST of any graph from this class in time $\O(n)$. (The constant hidden in the~$\O$
-depends on the class.)
-
-\proof
-Following the proof for planar graphs (\ref{planarbor}), we denote the graph considered
-by the algorithm at the beginning of the $i$-th iteration by~$G_i$ and its number of vertices
-and edges by $n_i$ and $m_i$ respectively. Again the $i$-th phase runs in time $\O(m_i)$
-and $n_i \le n/2^i$, so it remains to show a linear bound for the $m_i$'s.
-
-Since each $G_i$ is produced from~$G_{i-1}$ by a sequence of edge contractions,
-all $G_i$'s are minors of~$G$.\foot{Technically, these are multigraph contractions,
-but followed by flattening, so they are equivalent to contractions on simple graphs.}
-So they also belong to~$\cal C$ and by the previous theorem $m_i\le \varrho({\cal C})n_i$.
-\qed
-
-\rem\id{nobatch}%
-The contractive algorithm uses ``batch processing'' to perform many contractions
-in a single step. It is also possible to perform contractions one edge at a~time,
-batching only the flattenings. A~contraction of an edge~$uv$ can be performed
-in time~$\O(\deg(u))$ by removing all edges incident with~$u$ and inserting them back
-with $u$ replaced by~$v$. Therefore we need to find a lot of vertices with small
-degrees. The following lemma shows that this is always the case in minor-closed
-classes.
-
-\lemman{Low-degree vertices}\id{lowdeg}%
-Let $\cal C$ be a graph class with density~$\varrho$ and $G\in\cal C$ a~graph
-with $n$~vertices. Then at least $n/2$ vertices of~$G$ have degree at most~$4\varrho$.
-
-\proof
-Assume the contrary: let there be at least $n/2$ vertices with degree
-greater than~$4\varrho$.  Then $\sum_v \deg(v) > n/2
-\cdot 4\varrho = 2\varrho n$, which is in contradiction with the number
-of edges being at most $\varrho n$.
-\qed
-
-\rem
-The proof can be also viewed
-probabilistically: let $X$ be the degree of a vertex of~$G$ chosen uniformly at
-random. Then ${\bb E}X \le 2\varrho$, hence by the Markov's inequality
-${\rm Pr}[X > 4\varrho] < 1/2$, so for at least $n/2$ vertices~$v$ we have
-$\deg(v)\le 4\varrho$.
-
-\algn{Local Bor\o{u}vka's Algorithm \cite{mm:mst}}%
-\algo
-\algin A~graph~$G$ with an edge comparison oracle and a~parameter~$t$.
-\:$T\=\emptyset$.
-\:$\ell(e)\=e$ for all edges~$e$.
-\:While $n(G)>1$:
-\::While there exists a~vertex~$v$ such that $\deg(v)\le t$:
-\:::Select the lightest edge~$e$ incident with~$v$.
-\:::Contract~$G$ along~$e$.
-\:::$T\=T\cup \{ \ell(e_i) \}$.
-\::Flatten $G$, removing parallel edges and loops.
-\algout Minimum spanning tree~$T$.
-\endalgo
-
-\thm
-When $\cal C$ is a minor-closed class of graphs with density~$\varrho$, the
-Local Bor\o{u}vka's Algorithm with the parameter~$t$ set to~$4\varrho$ 
-finds the MST of any graph from this class in time $\O(n)$. (The constant
-in the~$\O$ depends on~the class only.)
-
-\proof
-Let us denote by $G_i$, $n_i$ and $m_i$ the graph considered by the
-algorithm at the beginning of the $i$-th iteration of the outer loop,
-and the number of its vertices and edges respectively. As in the proof
-of the previous algorithm (\ref{mstmcc}), we observe that all the $G_i$'s
-are minors of the graph~$G$ given as the input.
-
-For the choice $t=4\varrho$, the Lemma on low-degree vertices (\ref{lowdeg})
-guarantees that at least $n_i/2$ edges get selected in the $i$-th iteration.
-Hence at least a half of the vertices participates in contractions, so
-$n_i\le 3/4\cdot n_{i-1}$. Therefore $n_i\le n\cdot (3/4)^i$ and the algorithm terminates
-after $\O(\log n)$ iterations.
-
-Each selected edge belongs to $\mst(G)$, because it is the lightest edge of
-the trivial cut separating~$v$ from the rest of the graph (see the Blue
-Rule in \ref{rbma}). The steps 6 and~7 therefore correspond to the operation
-described by the Lemma on contraction of MST edges (\ref{contlemma}) and when
-the algorithm stops, $T$~is indeed the minimum spanning tree.
-
-It remains to analyse the time complexity of the algorithm. Since $G_i\in{\cal C}$, we have
-$m_i\le \varrho n_i \le \varrho n/2^i$.
-We will show that the $i$-th iteration is carried out in time $\O(m_i)$.
-Steps 5 and~6 run in time $\O(\deg(v))=\O(t)$ for each~$v$, so summed
-over all $v$'s they take $\O(tn_i)$, which is linear for a fixed class~$\cal C$.
-Flattening takes $\O(m_i)$, as already noted in the analysis of the Contracting
-Bor\o{u}vka's Algorithm (see \ref{contiter}).
-
-The whole algorithm therefore runs in time $\O(\sum_i m_i) = \O(\sum_i n/2^i) = \O(n)$.
-\qed
-
-\rem
-For planar graphs, we can get a sharper version of the low-degree lemma,
-showing that the algorithm works with $t=8$ as well (we got $t=12$ from the
-general version). While this does not change the asymptotic time complexity
-of the algorithm, the constant-factor speedup can still delight the hearts of
-its practical users.
-
-\lemman{Low-degree vertices in planar graphs}%
-Let $G$ be a planar graph with $n$~vertices. Then at least $n/2$ vertices of~$v$
-have degree at most~8.
-
-\proof
-It suffices to show that the lemma holds for triangulations (if there
-are any edges missing, the situation can only get better) with at
-least 3 vertices. Since $G$ is planar, $\sum_v \deg(v) < 6n$.
-The numbers $d(v):=\deg(v)-3$ are non-negative and $\sum_v d(v) < 3n$,
-hence by the same argument as in the proof of the general lemma, for at least $n/2$
-vertices~$v$ it holds that $d(v) < 6$, hence $\deg(v) \le 8$.
-\qed
-
-\rem\id{hexa}%
-The constant~8 in the previous lemma is the best we can have.
-Consider a $k\times k$ triangular grid. It has $n=k^2$ vertices, $\O(k)$ of them
-lie on the outer face and have degrees at most~6, the remaining $n-\O(k)$ interior
-vertices have degree exactly~6. Therefore the number of faces~$f$ is $6/3\cdot n=2n$,
-ignoring terms of order $\O(k)$. All interior triangles can be properly colored with
-two colors, black and white. Now add a~new vertex inside each white face and connect
-it to all three vertices on the boundary of that face. This adds $f/2 \approx n$
-vertices of degree~3 and increases degrees of the original $\approx n$ interior
-vertices to~9, therefore about a half of the vertices of the new planar graph
-has degree~9.
-
-\figure{hexangle.eps}{\epsfxsize}{The construction in Remark~\ref{hexa}}
-
-
-\section{Using Fibonacci heaps}
-\id{fibonacci}
-
-% G has to be connected, so m=O(n)
-% mention Steiner trees
-% mention matroids
-% sorted weights
-% \O(...) as a set?
-% impedance mismatch in terminology: contraction of G along e vs. contraction of e.
-% use \delta(X) notation
-
 \endpart